
 /* CDPLAY.PRG (c) Tom Grger 1994
    Sound & Vision for Clipper (c) Sample Code
    CD-Player */

    #include "SOUNDVIS.CH"
    #include "INKEY.CH"



  /* CD-Player Colors */

    #define  F_LGN       10               // BriGreen on Black
    #define  F_NGR      143               // BriWhite on grey
    #define  F_LRGR     140               // BriRed   on grey
    #define  F_YGR      142               // Yellow   on Grey
    #define  F_GN         2               // Green    on black
    #define  F_NG        32               // Black    on Green
    #define  F_WBLUE     31               // LiteWhite on Blue
    #define  F_NHB       48               // Black on LiteBlue
    #define  F_NW       112               // Black on White
    #define  F_RW       116               // Red on White
    #define  F_WBROWN   191               // LiteWhite on Brown (converted)
    #define  F_NBEIGE   208               // black on Beige     (converted)
    #define  F_RBEIGE   212               // red on Beige       (converted)


  /* CD-Player Events */

    #define CD_EXITUS     0
    #define CD_WINDOW     1
    #define CD_UPDATE     2
    #define CD_PLAY       3
    #define CD_PAUSE      4
    #define CD_BUTTON     5
    #define CD_STOP       6
    #define CD_INKEY      7
    #define CD_NEXT       8
    #define CD_PREVIOUS   9
    #define CD_MOVE      10
    #define CD_CHANGE    11
    #define CD_INC       12
    #define CD_DEC       13

    #define STD_INFO 'N/*RB,N/W,,,R/*RB'



    static aVolume := {8,8}
    static nTrack
    static nEvent := CD_WINDOW

    
/*
    FUNCTION cdplayer ()                                
  */

 PROCEDURE  CDPLAYER ()

    local nTRow := 8, nLCol := 5, nBRow := 18, nRCol := 73
    local nChoice := 2 , nX, nY, nKey, nVol
    local cOldColor := SETCOLOR ( STD_INFO ), oCdWin
    local nLastTrack, nFirstTrack
    local nDrive, aBinBut, nMouseRow, nMouseCol

    local cClose := oAddButt ( 2, 44, F_NW, F_RW, {"Clos~e"},  .F. )
    local cEject := oAddButt ( 2, 44, F_NW, F_RW, {"~Eject"},  .F. )
    local cLock  := oAddButt ( 2, 55, F_NW, F_RW, {" ~Lock "}, .F. )
    local cUnlock:= oAddButt ( 2, 55, F_NW, F_RW, {"Un~lock"}, .F. )
    local oEject, oLock


     nTrack := GetTrackCD( 0 )
     nEvent := CD_WINDOW


  /* Live : All happens within one big loop ( so watch your Karma :-))
    ------------------------------------------------------------------- */
     while nEvent # CD_EXITUS

        do case

          // -----------------------
          // Build CD-Player's Image
          // -----------------------
        case nEvent == CD_WINDOW

             CREATE WINDOW oCdWin                   ;
                    FROM nTRow,nLCol TO nbRow,nRCol  ;
                    TOPCOLOR F_NW                    ;
                    WINCOLOR F_NGR                   ;
                    TITLE 'CD-PLAYER'                ;
                    TYP WIN_MESSBUT                  ;
                    EVENT {|m,o|EVENT(m,o)}


             dispBegin()

             // CD-Display
             OutFrame ( 2, 4, 6, 40, 2, F_GN)


             // Volume Fader
             @  4, 51  SAY '-'
             @  4, 65  SAY '+'
             @  5, 43  SAY 'Vol L'
             @  6, 43  SAY 'Vol R'


             nX := SETCOLOR ("G/N")

             // LED-Display
             @  2,  5  SAY 'Track'
             @  2, 24  SAY 'Time'
             @  3, 24  SAY 'Song'
             @  4,  5  SAY 'Drive'
             @  4, 24  SAY 'Disc'

             SETCOLOR (nX)

             // Create Button Object
             aBinBut := oAddButt ( 9, 3, F_NW, F_RW,;
                 {'','','','','','','','Power'}, .F. )

             // Display Button Object
             oDisButt ( aBinBut, nChoice )

             // We need some Sound...
             if aVolume[1] + aVolume[2] < 4
                SetSbVol ( CH_CD, aVolume )
             endif

             dispEnd()


             nEvent := CD_CHANGE

          // ---------------------
          // Update Status-Display
          // ---------------------
        case nEvent == CD_UPDATE
             aVolume := GetSbVol( CH_CD )

             mse_show (.T.)

             dispBegin ()
             setColor ("+W/*N")

             for nX := 5 to 6
                 hlinie  ( nX, 51, 66,,'')
                 @ nX, aVolume[nX-4]+50  SAY  ''
             next

          /* Eject or close */
             oDisButt ( (oEject := iif (EjectCD(),cClose, cEject)),0)
             oDisButt ( (oLock  := iif (LockCD(), cUnlock, cLock)),0)

             if ChangedCD()
                nEvent := CD_CHANGE

             else
                if GetPauseCD()
                   @ 3, 5 SAY 'PAUSE' COLOR "+G/N"
                else
                   @ 3, 5 SAY '     ' COLOR "G/N"
                endif
                nTrack := GetTrackCD(0)

                @  2, 12  SAY GetTrackCD (3)    COLOR "+G/N" // Trackr
                @  2, 32  SAY RunTimeCD ()      COLOR "+G/N" // PlayTime
                @  3, 32  SAY GetVolCD (nTrack) COLOR "+G/N" // SongTime

                nEvent := CD_INKEY

              endif



              mse_show(.F.)
              dispEnd()


          // ------------------
          // New Media inserted
          // ------------------
        case nEvent == CD_CHANGE
             mse_show(.T.)
             nDrive := InitCD()


             dispBegin ()
             nVol := GetVolCD(-1)

             /* Show Total DiscTime */
             @  4, 32  SAY nVol COLOR "+G/N"

             /* Aktive Drive */
             @  4, 10  SAY STR(nDrive, 2) COLOR "+G/N"


             if nVol == "00.00"
                nFirstTrack := 0
                nLastTrack  := 0
                nEvent := CD_INKEY
             else
                nFirstTrack := GetTrackCD(1)
                nLastTrack  := GetTrackCD(2)
                nEvent := CD_UPDATE
             endif


             /* TrackNumbers: aktive Tracks in LightRed */
             FOR nX := 1 TO 9
                 nY := nX * 4
                 @ 5,nY SAY STR (nX,3) ;
                   COLOR iif (nX >= nFirstTrack .AND. ;
                              nX <= nLastTrack, "+R/N", "R/N" )
                 @ 6,nY SAY STR (nX+9,3) ;
                   COLOR iif (nX+9 >= nFirstTrack .AND. ;
                              nX+9 <= nLastTrack, "+R/N", "R/N" )
             NEXT


             mse_show (.f.)
             dispEnd()


          // -------------
          // Poll Keyboard
          // -------------
        case nEvent == CD_INKEY

             nKey := KeyReader (,.5,0)

             if nEvent == CD_INKEY
                nEvent := CD_UPDATE

                if nKey # 0

                 // Scan KeyCode
                 do case
                 case nKey == K_MOUSE
                      do case

                       // Mouse over Button ?
                     case ( nX := oMouseButt( aBinBut)) # nil
                          nChoice := oSetFocus ( aBinBut, nX )
                          nEvent  := CD_BUTTON


                       // Volume Left ?
                     case MSE_Check ( 5, 51, 5, 66, .t.)
                          aVolume[1] := (MSE_Col() - 51 )
                          SetSbVol ( CH_CD, aVolume )

                       // Volume Right ?
                     case MSE_Check ( 6, 51, 6, 66, .t.)
                          aVolume[2] := (MSE_Col() - 51 )
                          SetSbVol ( CH_CD, aVolume )


                     case ! (oMouseButt (oEject) == nil)
                          oSetFocus (oEject,1)
                          oPushButt (oEject)
                          ejectCD(!ejectCd())

                     case ! (oMouseButt (oLock) == nil)
                          oSetFocus (oLock,1)
                          oPushButt (oLock)
                          lockCD(!LockCd())


                       // No CD !
                     case nTrack == 0
                          nEvent := CD_INKEY


                       // Tracknumbers ?
                     otherwise

                          nMouseRow := MSE_Row()
                          nMouseCol := MSE_Col()

                          // Hit the Track-Index ?
                          if Mse_Check( 5, 4, 6, 38 )

                             // Yes, but which Track ...
                             FOR nY := 4 TO 36  STEP 4

                                 if nMouseCol >= nY .AND. nMouseCol <= nY+2
                                    nY /= 4
                                    nY := iif( nMouseRow == 5,nY,nY+9 )

                                    if nY >= nFirstTrack .AND. ;
                                       nY <= nLastTrack

                                       nTrack := nY
                                       nEvent := CD_PLAY
                                       EXIT

                                    endif
                                 endif
                             NEXT
                          endif
                     endcase

                  // HotKey ?
                case (nX := oKeyButt ( aBinBut, nKey )) # nil
                      nChoice := oSetFocus ( aBinBut, nX )
                      nEvent  := CD_BUTTON


                case nKey == K_LEFT  .OR. nKey == K_DOWN .OR. ;
                     nKey == K_RIGHT .OR. nKey == K_UP

                     nChoice := oSetFocus ( aBinBut, WrapWert          ;
                                   ( nKey == K_RIGHT .OR. nKey == K_UP,;
                                          nChoice, 1, 8 ))


                case nKey == K_HOME
                     nChoice := oSetFocus ( aBinBut, 1 )


                case nKey == K_END
                     nChoice := oSetFocus ( aBinBut, 8 )


                case nKey == K_ESC
                     nChoice := oSetFocus ( aBinBut, 8 )
                     nEvent :=  CD_EXITUS

                case nKey == K_ENTER
                     nEvent :=  CD_BUTTON

                case nKey == 45 // minus -> STEP 2 !!
                     aVolume[1] := MAX(1, aVolume[1]-2)
                     aVolume[2] := aVolume[1]
                     SetSbVol ( CH_CD, aVolume )

                case nKey == 43  // plus
                     aVolume[1] := MIN(15, aVolume[1]+1)
                     aVolume[2] := aVolume[1]
                     SetSbVol ( CH_CD, aVolume )


                case ! ( oKeyButt ( oEject, nKey ) == nil)
                     oSetFocus (oEject,1)
                     oPushButt (oEject)
                     ejectCD(!ejectCd())

                case ! ( oKeyButt ( oLock, nKey ) == nil)
                     oSetFocus (oLock,1)
                     oPushButt (oLock)
                     lockCD(!LockCd())


               otherwise
                     nKey   := 0

                endcase

             endif
           endif

          // ---------------
          // Activate Button
          // ---------------
        case nEvent == CD_BUTTON
             nChoice := oPushButt ( aBinBut )

          // Check for Action
             do case
             case nChoice == 1   ; nEvent := CD_DEC
             case nChoice == 2   ; nEvent := CD_PLAY
             case nChoice == 3   ; nEvent := CD_INC
             case nChoice == 4   ; nEvent := CD_NEXT
             case nChoice == 5   ; nEvent := CD_PAUSE
             case nChoice == 6   ; nEvent := CD_STOP
             case nChoice == 7   ; nEvent := CD_PREVIOUS

             case nChoice == 0 .OR. nChoice == 8
                  nEvent := CD_EXITUS

             otherwise
                  nEvent := CD_UPDATE

             endcase


          // --------------------------
          // Play Next / Previous Track
          // --------------------------
        case nEvent == CD_NEXT .OR. nEvent == CD_PREVIOUS
             nTrack := SkipCd(nEvent == CD_PREVIOUS)
             nEvent := CD_UPDATE

          // ------------------------
          // Incremet/Decrement Track
          // ------------------------
        case nEvent == CD_INC .OR. nEvent == CD_DEC
             nTrack := WrapWert ( (nEvent==CD_INC),;
                                   nTrack, nFirstTrack, nLastTrack )
             // Position Head at Track
             PlayCd (nTrack, 1, 0)
             nEvent := CD_UPDATE

          // ----------
          // Stop Track
          // ----------
        case nEvent == CD_STOP
             StopCD()
             nEvent := CD_UPDATE



          // ----------
          // Play Track
          // ----------
        case nEvent == CD_PLAY

             if nTrack # 0

                // Play Track, if input is valid
                PlayCd (nTrack, 0, -1)

             endif

             // Next Task: Update Display
             nEvent := CD_UPDATE

          // -----------
          // Pause Track
          // -----------
        case nEvent == CD_PAUSE
             iif (GetPauseCD(), ContinueCD(), PauseCD())
             nEvent := CD_UPDATE

        endcase

     end
     mse_show (.f.)

     oCdWin:Close()
     ExitCd()

 return


 STATIC FUNCTION EVENT (msg, oWin)
    if msg == WINMSG_CLOSE
       nEvent := CD_EXITUS
    endif
 RETURN .T.
