 /*
     PROGRAM .... :   Demo.prg
     AUTHOR ..... :   Tom Groeger
     DATE ....... :   10/08/94
                      Sound & Vision Demonstration

     Compile with CLIPPER DEMO.prg /m /n
     Link    with RTLINK FI DEMO, CDPLAY, COLORSET, DIRBROWSE,
                            MEMORY, MIXER, SYSINIT, RECORD,
                            ERRORSYS, GETSYS  LIB SoundVis

  */

 // INCLUDES
 // --------
 #include 'INKEY.CH'
 #include 'SET.CH'
 #include 'SOUNDVIS.CH'
 #include 'SVENGINE.CH'


 // Farben
 #define  F_NW       112
 #define  F_RW       116
 #define  F_WBROWN   191
 #define  F_NBEIGE   208
 #define  F_RBEIGE   212

 #define STD_INFO 'N/*RB,N/W,,,R/*RB'


 // Enable/Disable MenuObject
 STATIC oVocPlay
 STATIC oMainWin



 PROCEDURE Main

    /* Save Dos-Screen */
     LOCAL cDosScreen := ScrSave(0,0,SCRMAXROW(),SCRMAXCOL())

    /* WorkVars.. */
     LOCAL nKey, cYn, getlist := {}, oMenu

     LOCAL nY, nX := 1, nRow, nCol, cScreen, oIni


   /* Settings
     -------------- */
     SET(_SET_CURSOR,0)
     SET(_SET_DECIMALS,2)
     SET(_SET_WRAP,.t.)
     SET(_SET_SCOREBOARD,.f.)
     SET(_SET_DELIMITERS,.f.)
     SET DATE AMERICAN
     SETCANCEL(.F.)

    /* Greetings */

      Mse_Show (.f.)
      PlayVoc ( 'HOLO.WAV')

      IF ViewPcx ("SV.PCX")
         inkey(2)

         Rest_Font ()
         Set_Font()
         SetCursor (1)
         SetCursor (0)
      ENDIF

      SetPalette()
      SETCOLOR('RG+/RG')
      CLS


      WinDemo ()

   /* Read INI-File and set Defaults
     ------------------------------- */
     oIni := INIFILE():New ("SV.INI" )

     IF oIni:Ready()
        SetPref( C_POPCOL,    oIni:GetValue ("PopupColors","Window",  "N"))
        SetPref( C_POPKEY,    oIni:GetValue ("PopupColors","Hotkey",  "N"))
        SetPref( C_POPPASSIV, oIni:GetValue ("PopupColors","Passiv",  "N"))
        SetPref( C_POPSHORT,  oIni:GetValue ("PopupColors","ShortCut","N"))
        SetBlanker ( BLANKER():New (oIni:GetValue ("Blanker", "Time", "N" )))


     ENDIF
     oIni:Release()



  /* Hide Mouse at 13,39
    --------------------- */
     MSE_Set ( 13,39, .f.)


  /* Open MainWindow
    ----------------- */
     CREATE WINDOW  oMainWin FROM 1,2 TO 23, 77 ;
     TITLE 'SOUND & VISION Demonstration'  ;
     TOPCOLOR "W+/B" ;
     WINCOLOR "N/W" ;
     TYP WIN_FULL ;
     NOSHADOW ;
     GROUP PRIMEWIN

     ColorMe ( 3,2,19,71, 94)

     oMenu := CreateMenu()
     ATTACH MENU oMenu TO oMainWin


  /* Mainloop
    --------- */
     DO WHILE nKey # B_QUIT


       ACTIVATE WINDOW oMainWin TO nKey

       IF nKey == 50

            cScreen := SAVESCREEN(4,4,20,73)

            nX := 1
            Color2Num (94, .t.)

            FOR nRow := 1 TO 15
                FOR nCol := 1 TO 51 STEP 3
                     IF nX >= 242 .AND. nX <= 246
                        nX++
                     ELSE
                        @ nRow+3, nCol+14 SAY CHR( nX++)
                     ENDIF
                NEXT
            NEXT

            MSE_Show (.t.)
            INKEY(0)
            MSE_Show (.f.)

            RestScreen (4,4,20,73,cScreen)

          /* 28 Row Mode */

       ELSEIF nKey == 51

             oMainWin:Hide()

             mode_28()
             cls
             Set_Font( "svfont.014")

             oMainWin:Open()

             oMainWin:Sizeable := .t.
             oMainWin:Size (0,0,3,0)
             oMainWin:Sizeable := .f.
             colorme ( 3,2,22,71, 94)

          /* 25 Row Mode */
       ELSEIF nKey == 52

             oMainWin:Hide()

             mode_24()
             cls
             Set_Font()
             SetPalette()
             oMainWin:Open()

             oMainWin:Sizeable := .t.
             oMainWin:Size (0,0,-3,0)
             oMainWin:Sizeable := .f.
             colorme ( 3,2,19,71, 94)



       ELSEIF nKey == B_ESC

           /* Time to say Goodbye... */
              PlayVoc("INTRO.VOC")


            cYN  := 'Y'
            SETCURSOR(1)
            Describe ('~Terminate Program ? ',,,oMainWin)

            SETCOLOR(',N/*W')
            @ oMainWin:High - 2,27 Get cYN  PICT '!'
            READ

            IF cYN $ "YyJj"
               nKey := B_QUIT
            ELSE
              nKey := 0

            ENDIF

            SETCURSOR(0)

       ENDIF

   ENDDO


    /* Cleanup
      ---------- */
      MSE_SHOW(.F.)
      CLOSE WINDOW oMainWin

      Rest_Font()

      SETCOLOR( 'W/N' )
      ScrRest( cDosScreen )
      @ 24,0 SAY 'Hasta la vista, Baby'


  /* and goodbye */
      QUIT






********************************************
*
*  Create Menu - Objects
*
FUNCTION CreateMenu ()
    LOCAL aSystem := {}, aDatei := {}, aSubSub := {}
    LOCAL aPoint  := {}, aSub   := {}, aHaupt  := {}
    LOCAL oMenu

    // MenuArrays, DATEI
    // --------------------
    ADDITEM aDatei  PROMPT '~Windows' ;
                    CHOICE {||WINDEMO()}       ;
                    HELP 'Many Windows'

    ADDITEM aDatei  PROMPT '~Horizont.Buttons' ;
                    HELP 'Window with ~Buttonbar' ;
                    CHOICE                     ;
                    {||AlertBox(2,'DEMO.EXE Vers. 2.01  1994 Tom Groeger;'+;
                                  'Choose by Mouse, Cursor;'+;
                                  'or Keyboard',;
                                  {'~OK'}, nil, nil,;
                                   '[ABOUT]' ) }

    ADDITEM aDatei  PROMPT '~Vertical Buttons' ;
                    CHOICE {||VERTIKAL()}       ;
                    HELP 'Window with Buttonrow'

    ADDITEM aDatei  PROMPT '~Radio-Buttons'      ;
                    CHOICE {||RADIO()}           ;
                    HELP 'Window with Radio-Buttons'
    ADDSEP  aDatei

    ADDITEM aDatei  PROMPT '~Tbrowse-Demo'       ;
                    CHOICE {||TBDEMO()}          ;
                    HELP 'Resizeable Tbrowse-Demo with Mouse'

    ADDITEM aDatei  PROMPT '~Mixed Gets Demo'     ;
                    CHOICE {||MIXED()}            ;
                    HELP 'All together now...'

    ADDITEM aDatei  PROMPT '~CRC Calculation'      ;
                    CHOICE {||CRC()}              ;
                    HELP 'Get a Files CRC32-Checksum'
    ADDSEP  aDatei

    ADDITEM aDatei  PROMPT '~Question-Box'        ;
                    HELP 'Any Questions ?' ;
                    CHOICE                        ;
                    {||AlertBox(0,'Will you order Sound & Vision ;'+;
                                  'today ?',;
                          {'~Sure', '~Oops', '~Tomorrow...'})}

    ADDITEM aDatei  PROMPT '~AlertBox' ;
                    HELP 'Something strange has happend' ;
                    CHOICE  ;
                    {||AlertBox(1,'Continue to format Drive C: ?',;
                        {'~OK', 'Oh-~No!'})}

    ADDITEM aDatei  PROMPT '~FileBox'             ;
                    CHOICE {||Dirmanager('','*.*')} ;
                    HELP   'Filebox with Mousesupport' ;
                    SHORTCUT 'ALT-TAB'

    ADDSEP  aDatei

    ADDITEM aDatei  PROMPT 'E~xit Demo'        ;
                    CHOICE {||KillMenu(B_QUIT)}   ;
                    HELP 'Are you sure you want that ?' ;
                    SHORTCUT 'ALT-F4'


    // MenueArrays, SUBSUB
    // --------------------
    ADDITEM aSubSub PROMPT 'Shoot ~Point' ;
                    CHOICE 111              ;
                    HELP 'too loud'

    ADDITEM aSubSub PROMPT '~Hang Point'    ;
                    CHOICE 112                  ;
                    HELP 'too silent'

    ADDITEM aSubSub PROMPT 'dr~awn Point'    ;
                    CHOICE 113                  ;
                    HELP 'too ~good for him'

    ADDITEM aSubSub PROMPT 'Sla~in Point'  ;
                    CHOICE 114                  ;
                    HELP 'Yeah, got it !'


    // MenuArrays, SUB
    // ----------------
    ADDITEM aSub    PROMPT 'Create ~Point'   ;
                    CHOICE 101                  ;
                    HELP 'Genesis..'

    ADDITEM aSub    PROMPT  'Chang~e Point'    ;
                    CHOICE 102                  ;
                    HELP 'Make him fit'

    ADDITEM aSub    PROMPT  '~Kill Point'  ;
                    POPUP aSubSub               ;
                    HELP 'Ultima ratio..'       ;
                    SHORTCUT ''
    ADDSEP  aSub

    ADDITEM aSub    PROMPT 'De~lete Point'    ;
                    CHOICE 103                  ;
                    HELP 'How boring'


    // MenuArrays, POINT
    // ------------------
    ADDITEM aPoint  PROMPT '~O:Engine'            ;
                    ACTION {||CLASSBROWSE(oMainWin)} ;
                    HELP "Sound & Vision's Rear View Mirror ;-)"

    ADDITEM aPoint  PROMPT '~PCX-Viewer' ;
                    ACTION {||Pcx()} ;
                    HELP 'Display Pcx-File'

    ADDSEP  aPoint

    ADDITEM aPoint  PROMPT '~Another One'        ;
                    POPUP aSub                   ;
                    HELP 'Open Child-Popup' ;
                    SHORTCUT ''

    // MenueArrays, aSYSTEM
    // --------------------
    ADDITEM aSystem PROMPT '~Memory-Info' ;
                    CHOICE {||ShowMem()}    ;
                    HELP 'What are our Resources ?' ;
                    SHORTCUT ' ALT-M'

    ADDITEM aSystem PROMPT '~SetColor' ;
                    CHOICE {||VgaMenu()}        ;
                    HELP 'Change Color Palette';
                    SHORTCUT 'ALT-F'

    ADDITEM aSystem PROMPT '~Font' ;
                    CHOICE 50             ;
                    HELP 'Show current Font'

    ADDITEM aSystem PROMPT '~24 Row Mode active' ;
                    HELP 'Switch 25/28 Screen Row Mode';
                    ACTION {|o|KillMenu(IIF(o:check(),52,51))} ;
                    CHECKED

    ADDSEP  aSystem


    ADDITEM aSystem PROMPT  'Soundblaster ~Voc/Wav' ;
                    CHOICE {||VOC()} ;
                    HELP 'You got one ?' ;
                    HANDLE oVocPlay

    ADDITEM aSystem PROMPT 'S~oundblaster Fm' ;
                    CHOICE {||FM()} ;
                    HELP 'At least an Adlib ?'

    ADDITEM aSystem PROMPT 'Soundblaster ~Init' ;
                    CHOICE {||CHECKSB()} ;
                    HELP 'Check Port, DMA & IRQ'

    ADDSEP  aSystem

    ADDITEM aSystem PROMPT '~CD-Player'   ;
                    CHOICE {||CdPlayer()} ;
                    HELP 'Lets party'

    ADDITEM aSystem PROMPT '~Mixer' ;
                    CHOICE {||SbMixer()} ;
                    HELP 'Our Soundlab' ;
                    SHORTCUT 'F2'


    ADDITEM aSystem PROMPT '~Record' ;
                    CHOICE {||SbRecord()} ;
                    HELP 'The ~fabulous Sound & Vison Recorder'


    // MenueArrays, aHaupt
    // --------------------
    ADDITEM aHaupt  PROMPT '~Samples'    ;
                    POPUP  aDatei        ;
                    HELP  'Window/Button and other demos'

    ADDITEM aHaupt  PROMPT '~Menu' ;
                    POPUP  aPoint ;
                    HELP 'Pop-Up Demo/PCX Demo/ObjectBrowser'

    ADDITEM aHaupt  PROMPT 'Sy~stem'     ;
                    POPUP  aSystem       ;
                    HELP   'Other stuff'

    ADDITEM aHaupt  PROMPT  '~Help'  AT 65  ;
                    CHOICE  {||ADRESS()} ;
                    HELP 'I can help'

    // Merge all Menus to oMenu
    // -------------------------

    INIT MENU oMenu FROM aHaupt AT 1, 2


 RETURN (oMenu)




********************************************
*
*  Event FM-Sound()
*

 DEFINE EVENT PlayFm ()
   STATIC nX := 1

   // Kill Event after last Tone
   IF nX == 13
      FM_KeyOff ( 1 )
      FM_KeyOff ( 2 )
      FM_KeyOff ( 3 )
      FM_KeyOff ( 4 )

      nX := 1
      KillEvent ( ThisEvent() )

   ELSE

      // Play 4 Voices
      FM_KeyOn ( 1, nx , 2)
      FM_KeyOn ( 2, nx , 4)
      FM_KeyOn ( 3, 13-nx  , 2 )
      FM_KeyOn ( 4, 13-nx++, 4 )

   ENDIF

 RETURN nil


********************************************
*
 STATIC FUNCTION VERTIKAL()
  LOCAL oWin , xDummy1, getList := {}

         CREATE WINDOW oWin               ;
                FROM 6,25 TO 18,55        ;
                TITLE 'Vertical Buttons'  ;
                TOPCOLOR F_WBROWN         ;
                WINCOLOR F_NBEIGE         ;
                TYP WIN_MESSAGE

                @  5, 2 SAY 'Which Drive is'
                @  6, 2 SAY 'going to be'
                @  7, 2 SAY 'formatted ?'


                @  2, 21 GET xDummy1      ;
                         AS PUSHBUTTON    ;
                     {' ~A: ' ,           ;
                      ' ~B: ' ,           ;
                      ' ~C: ' ,           ;
                      ' ~D: ' ,           ;
                      '~Exit' }           ;
                COLOR F_NW  HOTKEY F_RW   ;
                INITIAL 3                 ;
                VERTIKAL

                READ

                CLOSE WINDOW oWin

 RETURN nil


********************************************
*
 STATIC FUNCTION RADIO()
  LOCAL oWin , nX, nChoice, GetList := {}


            CREATE WINDOW oWin                 ;
                   FROM 4,20 TO 18,58          ;
                   TITLE 'RADIO-Buttons'       ;
                   TOPCOLOR F_WBROWN           ;
                   WINCOLOR F_NBEIGE           ;
                   TYP      WIN_MESSAGE



            @  5,  7 GET nX                    ;
                     AS RADIOBUTTON            ;
                       {'Sh~ow All',           ;
                        '~Static Variables',;
                        'Public and ~Privates',;
                        '~Locals',             ;
                        '~None of them'}    ;
                     COLOR F_NBEIGE            ;
                     HOTKEY F_RBEIGE           ;
                     INITIAL 2                 ;
                     FRAME                     ;
                     ACTION {||PlayVoc ("LASER.VOC")}

            @ 12, 10 GET nChoice               ;
                     AS PUSHBUTTON             ;
                     { "~OK","Cance~l"}        ;
                     COLOR  F_NW               ;
                     HOTKEY F_RW               ;
                     INITIAL 1

            @  4, 10 SAY ' Variables '


            READ

            CLOSE WINDOW oWin

 RETURN nil




********************************************
*
 STATIC FUNCTION TBDEMO()
  LOCAL aFields


        IF FILE ( "SvDemo.Dbf" )

           DBUSEAREA (.T., "DBFNTX", "SvDemo.DBF", "DEMO", .T.)
           IF FILE ( "svDemo.ntx" )
              DBSETINDEX ( "svDemo.ntx" )

           ELSE
              INDEX ON demo->NAME TO SVDEMO.NTX

           ENDIF

           aFields := { {'Name',    {||demo->name}},;
                        {'Street',  {||demo->street}},;
                        {'City',    {||demo->city}},;
                        {'Country', {||demo->country}},;
                        {'Telefon', {||demo->tel}} }

           BROWSE TABLE FROM 5, 6 TO 19,72 FIELDS aFields
           USE

        ELSE
           AlertBox (1,'File not found', {'~Ok'})
        ENDIF

  RETURN (.T.)


********************************************
*

  STATIC FUNCTION CRC()
   LOCAL xDummy1 := DirManager ('','*.*')
   LOCAL oWin, nCrc, Getlist := {}
   LOCAL nKey

      IF LEN(xDummy1) > 0

            CREATE WINDOW oWin              ;
                   FROM  8, 10 TO 16, 70    ;
                   TITLE 'CRC-Check'        ;
                   TYP WIN_MESSAGE          ;
                   TOPCOLOR F_WBROWN        ;
                   WINCOLOR F_NBEIGE        ;


          /* Turn mouse into sandglass */
            MSE_Wait ( .t. )
            MSE_Set ( 14, 45, .t.)

          /* calculate CRC-CheckSum */
            nCrc := GetCrc32 ( xDummy1 )


          /* normal mouse cursor */
            MSE_Wait (.f.)
            MSE_Show(.f.)


          /* show CRC-CheckSum */
           @  4,  7 SAY  SPACE( 52)
           @  3,  7 SAY  'The CRC of '+ xDummy1 +' is'
           @  4, 25 SAY   nCrc COLOR "R/*RB"


          /* Ok ? */
           @  6, 24 GET nKey                   ;
                    AS PUSHBUTTON {'  ~OK  '}  ;
                    COLOR F_NW  HOTKEY F_RW    ;
                    TIMEOUT 5

         READ

         CLOSE WINDOW  oWin

      ENDIF

 RETURN nil


********************************************
*
 STATIC FUNCTION ADRESS()

  LOCAL Getlist := {}, xDummy, oWin


     CREATE WINDOW oWin FROM 6, 20 TO 21, 60 ;
            TITLE "Sound & Vision"           ;
            TOPCOLOR "W+/BG*"                ;
            WINCOLOR "N/RB*"                 ;
            TYP WIN_MESSAGE

            SETCOLOR ("N/RB*")
            dispbegin ()

            @ 02,06 SAY 'Copyright  Tom Groeger 1994' COLOR "R/RB*"
            @ 04,12 SAY 'Distributed by:'
            @ 05,13 SAY 'SOFTSOL GmbH' COLOR "R/RB*"
            @ 06,11 SAY 'Neue Strasse 35a'
            @ 07,07 SAY ' D-21073 HAMBURG/Germany'
            @ 08,10 SAY 'Tel: +49-40-7661290'
            @ 09,10 SAY 'Fax: +49-40-7665664'
            @ 10,10 SAY 'CIS:    100112,3401'

            @ 12,14 GET xDummy AS PUSHBUTTON {'  ~OK  '}  ;
                    COLOR  F_NW  ;
                    HOTKEY F_RW  ;
                    TIMEOUT 10

            dispEnd()

            READ

            CLOSE WINDOW oWin

 RETURN nil



********************************************
*
 STATIC FUNCTION FM()

  LOCAL aPiano  := {  1,   17,  77,  0, 241, 210, 96, 123, 00, 00, 08 }
  LOCAL aString := { 113, 161, 139, 64, 113,  66, 17,  21, 00, 00, 06 }


       // Load Voice
       FM_Instr (1, aPiano)
       FM_Instr (2, aPiano )
       FM_Instr (3, aString )
       FM_Instr (4, aString )

       // Start PlayEvent
       NEWEVENT every 8 ticks call PlayFM


  RETURN (.T.)


********************************************
*
STATIC FUNCTION CheckSb()
LOCAL  xDummy1, aInit

   PlayStop()

   IF ! SbInit ()
      oVocPlay:SetEnable (.F.)
      xDummy1 := 'Initializing failed !;'

   ELSE
      oVocPlay:SetEnable (.T.)
      xDummy1 := 'SoundBlaster has been initialized;'

   ENDIF

   aInit := SbGetInit()

   xDummy1 += 'PortAdress  : '+STR(aInit[1],3)+';'+;
              'IRQ-Number  : '+STR(aInit[2],3)+';'+;
              'DMA-Channel : '+STR(aInit[3],3)+';'+;
              'SB-Version  : '+STR(aInit[4],3)


   AlertBox (2, xDummy1, { '~OK '} )

 RETURN nil


********************************************
*
 STATIC FUNCTION VOC( u )
  LOCAL cFile

        cFile := DirManager ('','*.VOC','*.WAV')

        IF LEN ( cFile ) > 0
           PlayVoc ( cFile )
        ENDIF
 RETURN (.T.)


********************************************
*
 STATIC FUNCTION PCX ( u )
  LOCAL cFile, cScreen

        cFile := DirManager ('','*.PCX')

        IF LEN ( cFile ) > 0

           cScreen := ScrSave (0,0, ScrMaxRow(), ScrMaxCol() )
           Mse_Show (.f.)

           IF ViewPcx ( cFile )
              inkey(0)

              Rest_Font ()
              Set_Font()
              SetPalette()
              SetCursor (1)
              SetCursor (0)

              ScrRest ( cScreen )


           ENDIF
        ENDIF

 RETURN (.T.)



********************************************
*
 STATIC FUNCTION MIXED()


  /* Vars must be Static, if an Input-Window is written once
     and only opened afterwards ! */

  STATIC oWin
  LOCAL  nButton, cBedarf, cStatus, lWerbung
  LOCAL  lMahnung, lNotizen , nZahl, dDatum, nUmsatz
  LOCAL  cDummy := "         "

  LOCAL  HelpColor, getlist := {}, nY
  LOCAL  aBedarf := { 'High  ',;
                      'Medium',;
                      'Low' }
  LOCAL  aStatus := { 'Client     ',;
                      'Target     ',;
                      'Dealer     ',;
                      'Friend     ',;
                      'NoNo       '}

  #define F_BBEIGE  209



 /* Enable ALT-D (disable Debuggercall) */
   ALTD(0)


 /* Set Helpline-Color to window-Color */
   HelpColor := SetPref (C_MASKWIN, color2num (STD_INFO))



  /* Create Window, if this has not been done */
  IF oWin == nil

     CREATE WINDOW oWin FROM 4, 15 TO 20, 66 ;
            TITLE    "[STATUS]" ;
            TOPCOLOR "W+/BG*" ;
            WINCOLOR STD_INFO ;
            TYP      WIN_LISTHELP ;      // List & MenuArea
            EVENT    {|m,o|MixEvent(m,o)}

            DispBegin ()
            DISPBOX (6,27,10,47 )
            SETCOLOR ( STD_INFO )

         /* Read as 'Framed' Get
           ---------------------- */
            @  2, 04 GET cStatus AS LISTBOX aStatus  ;
                         INITIAL 1 ;
                         FRAME IN F_NW ;
                         SHORTCUT ALT-S ;
                         PROMPT '~Status' HOTKEY F_BBEIGE ;
                         DESCRIBE "Alt-S : ~PopUp Listbox"

            @  2, 30 GET cBedarf AS SPINNER ;
                         INITIAL 1 ;
                         LIST aBedarf ;
                         FRAME IN F_NW ;
                         SHORTCUT ALT-T ;
                         PROMPT '~Turn  ' HOTKEY F_BBEIGE    ;
                         DESCRIBE "Ctrl-Up : ~INC  Ctrl-Dn : ~DEC"


            @  4, 04 GET dDatum  AS SPINNER ;
                         INITIAL Date() ;
                         FRAME IN F_NW ;
                         SHORTCUT ALT-D ;
                         PROMPT '~Date ' HOTKEY F_BBEIGE ;
                         DESCRIBE "Enter : ~Select"


            @  4, 30 GET nUmsatz AS SPINNER ;
                         INITIAL 1250 ;
                         RANGE FROM 0 TO 2000 ;
                         FRAME IN F_NW ;
                         SHORTCUT ALT-L ;
                         PROMPT '~Limit' HOTKEY F_BBEIGE ;
                         DESCRIBE "Range : 0 - ~1300" ;
                         PICTURE '99999'

            @ 07, 05 GET nZahl AS RADIOBUTTON ;
                          {'~Prepayment',;
                           'C~OD',;
                           '~Invoice'} ;
                         SHORTCUT ALT-P, ALT-O, ALT-I ;
                         COLOR F_NBEIGE ;
                         HOTKEY F_RBEIGE ;
                         DESCRIBE "Space : ~Toggle" ;
                         INITIAL 2 ;
                         FRAME  ;
                         ACTION {||PlayVoc ("LASER.VOC")}


          @  7, 29 GET lWerbung AS CHECKBOX '~Advertising ?' ;
                         INITIAL .T. ;
                         SHORTCUT ALT-A ;
                         COLOR F_NBEIGE ;
                         HOTKEY F_BBEIGE ;
                         DESCRIBE "Space : ~Check/UnCheck"


            @  8, 29 GET lMahnung AS CHECKBOX '~Reminder ?'  ;
                         INITIAL .F.;
                         SHORTCUT ALT-R ;
                         COLOR F_NBEIGE ;
                         HOTKEY F_BBEIGE ;
                         DESCRIBE "Enter : ~Select"

            @  9, 29 GET lNotizen AS CHECKBOX 'Clip~Board ?' ;
                         INITIAL .T. ;
                         SHORTCUT ALT-B ;
                         COLOR F_NBEIGE ;
                         HOTKEY F_BBEIGE ;
                         DESCRIBE "Hotkey : ~GoTo"



            @ 12,  4 GET nButton AS PUSHBUTTON  ;
                 {' Sa~ve',' Pri~nt ',' Canc~el ' } ;
                         INITIAL 2 ;
                         SHORTCUT ALT-V, ALT-N , ALT-E ;
                         DESCRIBE "Select: ~Enter" ;
                         ACTION {||PlayVoc ("DROP.VOC")}


            @  6, 07 SAY ' Payment '
            @  6, 32 SAY ' Info '

            DispEnd()


         /* Attach all Gets to the Window */
           ATTACH CONTROLS TO oWin START AT 1

   ENDIF

   /* Open Window & Read Controls */
    ACTIVATE WINDOW oWin


    /* DeActivate Window */
     HIDE WINDOW oWin
     SetPref (C_MASKWIN, HelpColor )


 RETURN (.T.)


 STATIC FUNCTION MixEvent (msg, oWin )
   IF msg == WINMSG_CLOSE
      readKill (.t.)
      KillTb()
   ENDIF
  RETURN .t.




FUNCTION WINDEMO ()
 LOCAL Obj, Obj1, obj2, obj3, obj4, obj5
 LOCAL getlist := {}, row, col, nKey

    MSE_SHOW(.t.)


        CREATE WINDOW obj1 ;
               FROM 4,3  TO 14, 40 ;
               TITLE "LISTBOX" ;
               TYP WIN_LISTHELP ;
               TOPCOLOR 48 ;
               WINCOLOR "BG/B"


        CREATE WINDOW obj2 ;
               FROM 1,30 TO 19, 50 ;
               TITLE "MESSAGE" ;
               TYP WIN_MESSAGE ;
               TOPCOLOR F_WBROWN ;
               WINCOLOR F_NBEIGE

        CREATE WINDOW obj3 ;
               FROM 14,38 TO 21, 70 ;
               TITLE "DIALOG" ;
               TYP WIN_LISTHELP ;
               TOPCOLOR "+W/G" ;
               WINCOLOR "N/R"


        CREATE WINDOW obj4 ;
               FROM 13, 9 TO 27, 40 ;
               TITLE "VIRTUAL" ;
               TYP WIN_LIST ;
               TOPCOLOR "BR+/W*" ;
               WINCOLOR "N/GR*"


        CREATE WINDOW obj5 ;
               FROM 10, 20 TO 16,60 ;
               TITLE 'SOUND & VISION Demonstration'  ;
               TYP WIN_FULL ;
               TOPCOLOR "+W/B" ;
               WINCOLOR "N/W" ;
               NOSHADOW
        obj5:SizeAble := .t.


        CREATE WINDOW obj ;
               FROM 5,52 TO 16, 76 ;
               TITLE "MOVEABLE" ;
               TYP WIN_MESSAGE

               @ 4, 5 SAY "  WELCOME TO"
               @ 5, 5 SAY "SOUND & VISION"
               @ 7, 6 SAY SvVersion()
               @ 9, 9 GET nKey AS PUSHBUTTON ;
                          {" ~OK "} ;
                          TIMEOUT 5 ;
                          INITIAL 1


        row := 4

        FOR col := 51 TO 25  STEP -1
            IF col < 37
               row--
            ELSE
               row++
            ENDIF
            Obj:Move(row,col)
        NEXT
        MSE_SHOW(.f.)


        READ

        FOR col := 1 TO 35

            DO CASE
            CASE col < 10
                 obj5:Size(1,1,1,1)
            CASE col < 19
                 obj5:Size(0,1,0,1)
            OTHERWISE
               obj5:Size(-1,-1,-1,-1)
            ENDCASE

        NEXT
        inkey(.5)

        obj:Close()
        inkey(.1)

        obj1:Close()
        inkey(.1)

        obj2:Close()
        inkey(.1)

        obj3:Close()
        inkey(.1)

        obj4:Close()
        inkey(.1)

        obj5:Close()


RETURN nil



STATIC FUNCTION SetPalette ()

    /* Set Colors
      ------------------------ */
      SetDAC (C_RB,  25, 17, 23)         // purple turns Brown/Red
      SetDAC (C_RG,  41, 31, 24)         // set brown
      SetDAC (C_HW,  55, 55, 55)         // set light white
      SetDac (C_HBG, 34, 18, 26)         // +lightblue turns redbrown
      SetDac (C_HRB, 42, 41, 36)         // lightpurple turns yellow
      SetDac (C_HRG, 63, 54, 21)         // lightyellow turns yellow

      SETBLINK(.f.)

RETURN nil


 *********** EOF Demo.prg **********

