
 /* DIRBOWSE.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


 #include "SOUNDVIS.CH"
 #include "INKEY.CH"
 #include "SVENGINE.CH"


 #define  DIR_EXIT    -5
 #define  DIR_INFILE  -6
 #define  DIR_INDIR   -7
 #define  DIR_INMASK  -8
 #define  DIR_INPATH  -9

 #define  DIR_MASK    1
 #define  DIR_LOAD    2
 #define  DIR_SHOW    3
 #define  DIR_NEWPATH 8
 #define  DIR_BUTTON  9

 #define  F_NAME      1

 #define  F_WBLUE     31               // LiteWhite on Blue
 #define  F_NHB       48               // Black on LiteBlue
 #define  F_NW       112               // Black on White
 #define  F_RW       116               // Red on White
 #define  F_WBROWN   191               // LiteWhite on Brown (converted)
 #define  F_NBEIGE   208               // black on Beige     (converted)
 #define  F_RBEIGE   212               // red on Beige       (converted)



/*
    DIRMANAGER ( cMaske ) -> cFileName                  
    Ready-to-use Windows - like Filemanager             
    with Mousesupport. Uses lots of Sound&Vision        
    stuff ...                                           
  */

  FUNCTION DirManager ( cPath, cFile, cAlter )

   LOCAL nTRow := 4, nLCol := 10, nBRow := 20, nRCol := 66

   LOCAL aFile  := {}, aDir := {}, nFiles, nDirs

   LOCAL aBut := { '  ~OK  ','~Retry ','~Cancel' }

   LOCAL nX, nY, nSelect, oWin, cTemp, cFileName := ''

   LOCAL cOldColor := SETCOLOR ( 'N/W,+W/N')

   LOCAL nEvent := DIR_MASK, nButton

   LOCAL lMouseStat := Mse_Show ( .f.)

   LOCAL Getlist := {}

   LOCAL aMse := { { 5,  0, 14,  0, 0          } ,;
                   { 3,  4,  3, 17, DIR_INMASK } ,;
                   { 3, 24,  3, 51, DIR_INPATH } ,;
                   { 9, 44,  9, 52, DIR_EXIT   } }

    // Allow to leave Get
   LOCAL lReadExit := ReadExit ( .t.)


   DEFAULT cPath TO ""
   DEFAULT cFile TO "*.*"


   DO WHILE nEvent != DIR_EXIT

      DO CASE

        // Build Screen
        // ============
      CASE nEvent == DIR_MASK
           CREATE WINDOW oWin                    ;
                  FROM nTRow, nLCol TO nBrow, nRCol ;
                  TITLE 'Directory Manager'         ;
                  TOPCOLOR 31                       ;
                  WINCOLOR 208                      ;
                  TYP   WIN_MESSAGE ;
                  EVENT {|m,o| killDir(m,o)}

        // Show Text
           @ 2,  4 SAY 'Filename:'
           @ 2, 24 SAY 'Directories:'

        // Display Buttons
           @ 5, 43 GET nButton ;
                   AS PUSHBUTTON aBut ;
                   COLOR  112 ;
                   HOTKEY 116 ;
                   VERTIKAL

           ATTACH CONTROLS TO oWin


        // Next Stop at ..
           nEvent := DIR_LOAD


         // Load Directories
         // ================
      CASE nEvent == DIR_LOAD

        // Get Path
           cPath := IIF( cPath == '', '\'+CURDIR()+'\', cPath )

        // Get Mask
           cFile := IIF( cFile == '', '*.*', cFile )


        // Read Directorys and Files
        // -------------------------
           aFile := {}
           aDir  := {}

           AEVAL ( DIRECTORY ( cPath-'*.', "D"),;
                      {|aDatei| AADD ( aDir, PADR(aDatei [F_NAME],12))})

           AEVAL( DIRECTORY ( cPath-cFile ),;
                     {|aDatei| AADD ( aFile, PADR(aDatei [F_NAME],12))})

           IF ! ( cAlter == nil )
                  AEVAL( DIRECTORY ( cPath-cAlter),;
                     {|aDatei| AADD ( aFile, PADR(aDatei [F_NAME],12))})
           ENDIF

           nFiles := LEN( aFile )
           nDirs  := LEN( aDir  )


           IF nFiles + nDirs == 0
              cPath := 'C:\'
              nEvent := DIR_INPATH

           ELSE
              nEvent := DIR_SHOW

           ENDIF

           @  3,  4 SAY PADR(cFile, 12) COLOR "N/*RB"
           @  3, 24 SAY PADR(cPath, 30) COLOR "N/*RB"

           IF ! ( cAlter == nil )
              @  3, 10 SAY cAlter COLOR "N/*RB"
           ENDIF


        // Show Dir- and Filebox
        // ---------------------
      CASE nEvent == DIR_SHOW

           SETCOLOR ( "N/W" )

           aListBox ( 5,  3, 14,  19, 3, 112)
           aListBox ( 5, 23, 14,  39, 3, 112)


           FOR nX := 1 TO 10
               IF nX <= nFiles
                  @  nX+4, 4  SAY aFile [nX]
               ENDIF

               IF nX <= nDirs
                  @  nX+4, 24 SAY aDir [nX]
               ENDIF

           NEXT


           // What's next ?
           DO CASE
           CASE nFiles == 0
                nEvent := DIR_INDIR

           CASE nDirs == 0
                nEvent := DIR_INFILE

           CASE aMse[1, MSE_RET] == DIR_INFILE
                nEvent := DIR_INDIR

           OTHERWISE
                nEvent := DIR_INFILE

           ENDCASE


        // Activate File-Box
        // =================
      CASE nEvent == DIR_INFILE

           IF nFiles == 0
              nEvent := DIR_INMASK

           ELSE

              // set MouseArray [1] to DIR_INDIR
             aMse [1, MSE_LCOL] := 23
             aMse [1, MSE_RCOL] := 23+13
             aMse [1, MSE_RET ] := DIR_INDIR

             /* 'TBrowse' a File */
             nSelect := memBrowse( 5, 3, 14, 17, aFile, aMse)

             /* found any Files ? */
             DO CASE
             CASE nSelect  > 0

                  @ 3, 4  SAY  aFile[nSelect] COLOR "N/*W"
                  nEvent := DIR_BUTTON


             CASE nSelect == B_RIGHT
                  nEvent :=  DIR_INDIR

             CASE nSelect == B_LEFT
                  nEvent :=  DIR_INMASK

             CASE nSelect == B_ESC
                  nEvent  := DIR_EXIT

                // MouseReturn
             OTHERWISE
                  nEvent :=  nSelect

             ENDCASE

           ENDIF

        // Activate Dir-Box
        // ================
      CASE nEvent == DIR_INDIR


           IF nDirs == 0
              nEvent := DIR_INPATH

           ELSE

             // set MouseArray to DIR_INFILE
             aMse [1, MSE_LCOL] :=  3
             aMse [1, MSE_RCOL] := 16
             aMse [1, MSE_RET ] := DIR_INFILE

             nSelect := memBrowse( 5, 23, 14, 37, aDir, aMse)

             DO CASE
             CASE nSelect  > 0
                  nEvent := DIR_NEWPATH

             CASE nSelect == B_LEFT
                  nEvent :=  DIR_INFILE

             CASE nSelect == B_RIGHT
                  nEvent :=  DIR_INPATH

             CASE nSelect == B_ESC
                  nEvent  := DIR_EXIT

                // MouseReturn
             OTHERWISE
                  nEvent :=  nSelect

             ENDCASE

           ENDIF


        // Rework new Path
        // ===============
      CASE nEvent == DIR_NEWPATH

           cPath := TRIM( cPath )

           DO CASE
           CASE LEFT( aDir[nSelect], 2 ) == '. '
                nEvent := DIR_SHOW

           CASE LEFT( aDir[nSelect], 2 ) == '..'
                cPath  := LEFT( cPath, LEN( cPath)-1 )
                cPath  := LEFT( cPath, RAT( '\', cPath))

                nEvent := DIR_LOAD

           OTHERWISE
                cPath  := cPath-aDir[nSelect]-'\'
                nEvent := DIR_LOAD

           ENDCASE


        // Input new Path
        // ==============
      CASE nEvent == DIR_INPATH
           cPath := PADR( cPath, 28 )

           @ 3, 24 GET cPath
           READ

           cPath := TRIM( cPath )
           IF RIGHT( TRIM(cPath), 1) != '\'
              cPath := cPath-'\'
           ENDIF

           nEvent := DIR_LOAD


        // Input new FileMask
        // ==================
      CASE nEvent == DIR_INMASK
           cFile :=  PADR( cFile, 12 )

           @ 3, 4 GET cFile  VALID AT('.', cFile) != 0
           READ

           cFile := TRIM ( cFile )
           nEvent := DIR_LOAD


        // Get final OK
        // ============
      CASE nEvent == DIR_BUTTON
           ACTIVATE WINDOW oWin

           DO CASE
           CASE nButton == 1
                cFileName := cPath-TRIM(aFile[nSelect])
                nEvent := DIR_EXIT

           CASE nButton == 2
                nEvent := DIR_LOAD

           OTHERWISE
                nEvent := DIR_EXIT

           ENDCASE

      ENDCASE

   ENDDO

   // Housekeeping
   READEXIT ( lReadExit )
   SETCOLOR ( cOldColor )

   CLOSE WINDOW  oWin
   MSE_SHOW ( lMouseStat )

 RETURN( TRIM(cFileName))



/*
    KillDir()                                           
    Small Eventhandler for Mse->CloseButton             
  */

 STATIC FUNCTION KillDir (nMessage,oWin)
        IF nMessage == WINMSG_CLOSE
           KillTb()
           ReadKill (.t.)
        ENDIF
 RETURN .t.
