
 /* MIXER.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include 'INKEY.CH'


  #define  F_NW       112               // Black on White
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)

  #define EVENT_EXIT   0
  #define EVENT_UPDATE 1
  #define EVENT_INKEY  2

  // Number of Channels
  #define CH_LEN       6

  #define STD_INFO 'N/*RB,N/W,,,R/*RB'


/*
    SbMixer () -> nil                                   
    If you own a Soundblaster PRO you can use its       
    Mixer and control the Master/Voc/Fm/Cd/Line and     
    Microphone Volume with this handy function.         
                                                        
    It also shows the usage of GETSBVOL() and           
    SETSBVOL().                                         
                                                        
  */


  FUNCTION SbMixer ()

     LOCAL oWin, nX, nY, nKey, Getlist := {}

     LOCAL nKanal := CH_MASTER

     LOCAL nEvent := EVENT_UPDATE

     LOCAL oL, oR, aVolume [2]

     LOCAL nFocus := 3

     LOCAL aSource := {'Master','Voice ','FM    ', ;
                       'CD    ','Line  ','Mikro ' }


     CREATE WINDOW  oWin ;
            FROM 1,25 TO 22,48 ;
            TITLE 'SBPRO-Mixer' ;
            topcolor 47 ;
            wincolor F_NBEIGE ;
            typ WIN_MESSAGE

     SETCOLOR  ( STD_INFO )
     MSE_SHOW (.T.)

     DISPBEGIN()

     oL := ScrollBar ():New ( 3, 2, 19, .f., 0):Show()
     oR := ScrollBar ():New ( 3, 6, 19, .f., 0):Show()

     oL:UpAction     := {||nKey := K_UP,  nFocus := 3}
     oR:UpAction     := {||nKey := K_UP,  nFocus := 3}
     oL:DownAction   := {||nKey := K_DOWN,nFocus := 3}
     oR:DownAction   := {||nKey := K_DOWN,nFocus := 3}


     /* Show Scala and Description
        -------------------------- */
     FOR nX := 1 TO 15
         Hlinie ( 19 - nX, 4, 6 )
     NEXT

     @ 2, 11 SAY 'Channel'
     MSE_SHOW (.F.)
     DISPEND()


     /* Mainloop
        ======== */
     DO WHILE nEvent # EVENT_EXIT

        DO CASE

        CASE nEvent == EVENT_UPDATE

             /* Read Mixer Registers  */
             aVolume  := GetSbVol ( nKanal )

             MSE_SHOW (.T.)
             DISPBEGIN()

             /* Set Scrollthump */
             oL:SetPos ( 19-aVolume[1] )
             oR:SetPos ( 19-aVolume[2] )

             /* Show active Channel */

             FOR nX := 1 TO CH_LEN
                 OutLine ( 1+ (nX*3), 11,;
                    aSource [nX], IIF ( nKanal+1 == nX, 2,1), F_NW )
             NEXT

             @ 2, 2 SAY 'L' COLOR IIF( nFocus == 1 .OR. nFocus == 3, ;
                                       "R/*RB", "N/*RB" )
             @ 2, 6 SAY 'R' COLOR IIF( nFocus == 2 .OR. nFocus == 3, ;
                                       "R/*RB", "N/*RB" )

             MSE_SHOW(.F.)
             DISPEND ()

             nEvent := EVENT_INKEY



        CASE nEvent == EVENT_INKEY

             nKey := KeyReader (nil, 0)


             IF nKey == K_MOUSE

                 /* Mouse on left or right Slider ?
                    ------------------------------- */
                IF ( nX := MAX ( oL:GetMouse(), oR:GetMouse()) ) # 0

                    nFocus := IIF (ScrollMse (oL:cHandle) == 0,2,1)

                  /* calc and set Value */
                    aVolume [nFocus] := 16-nX
                    SetSbVol( nKanal, aVolume)
                    nEvent := EVENT_UPDATE


                 /* Switch to a new Channel ?
                    ------------------------- */
                ELSE

                  /* But which ? */
                    FOR nX := 1 TO CH_LEN
                        IF MSE_CHECK (nX*3+1,11,,16 )
                           nKanal := nX-1
                           nFocus := 3
                           nEvent := EVENT_UPDATE
                           EXIT
                        ENDIF
                    NEXT

                ENDIF

             ENDIF

             DO CASE

              /* Previous Channel
                 ---------------- */
             CASE nKey == K_PGUP
                  nKanal := WrapWert ( .f., nKanal, 0, 5 )
                  nEvent := EVENT_UPDATE


              /* Next Channel
                 ------------ */
             CASE nKey == K_PGDN
                  nKanal := WrapWert ( .t., nKanal, 0, 5 )
                  nEvent := EVENT_UPDATE


              /* Channel L-R-BOTH
                 ---------------- */
             CASE nKey == K_LEFT .OR. nKey == K_RIGHT
                  nFocus := WrapWert ( nKey == K_RIGHT, nFocus, 1, 3)
                  nEvent := EVENT_UPDATE


             CASE nKey == K_HOME .OR. nKey == K_END
                  IF nFocus == 1 .OR. nFocus == 3
                     aVolume[1] := IIF (nKey == K_HOME, 15, 1)
                  ENDIF
                  IF nFocus == 2 .OR. nFocus == 3
                     aVolume[2] := IIF (nKey == K_HOME, 15, 1)

                  ENDIF
                  SetSbVol ( nKanal, aVolume )
                  nEvent := EVENT_UPDATE


              /* Increase / Decrease Volume
                 -------------------------- */
             CASE nKey == K_UP .OR. nKey == K_DOWN

                  /* Left or both Channels */
                  IF nFocus == 1 .OR. nFocus == 3
                     aVolume[1] := IIF ( nKey == K_UP,;
                                         MIN ( 15, aVolume [1]+2),;
                                         MAX (  1, aVolume [1]-2))
                  ENDIF


                  /* Right or both Channels */
                  IF nFocus == 2 .OR. nFocus == 3
                     aVolume [2] := IIF ( nKey == K_UP,;
                                          MIN ( 15, aVolume [2]+2),;
                                          MAX (  1, aVolume [2]-2))
                  ENDIF

                  SetSbVol ( nKanal, aVolume )
                  nEvent := EVENT_UPDATE


              /* No more, Mr.Nice Guy
                 -------------------- */
             CASE lastkey() == K_ESC
                 nEvent := EVENT_EXIT

             ENDCASE


        ENDCASE

     ENDDO

     CLOSE WINDOW oWin

  RETURN ( nil )

  /* SbMixer ENDP */
