
 /* RECORD.PRG  Tom Groeger 1993
    Sound & Vision for Clipper (c) Demonstration Code  */


  #include "SOUNDVIS.CH"
  #include 'INKEY.CH'


  #define  F_NW       112               // Black on White
  #define  F_RW       116               // Red on White
  #define  F_WBROWN   191               // LiteWhite on Brown (converted)
  #define  F_NBEIGE   208               // black on Beige     (converted)
  #define  F_RBEIGE   212               // red on Beige       (converted)

  #define EVENT_EXIT   0
  #define EVENT_INIT   1
  #define EVENT_UPDATE 2
  #define EVENT_INKEY  3
  #define EVENT_RECORD 4
  #define EVENT_BUTTON 5
  #define EVENT_WAIT   6


  // Number of Channels
  #define CH_LEN       6

  #define STD_INFO 'N/*RB,N/W,,,R/*RB'


/*
    SbRecord () -> nil                                  
                                                        
    This DemoCode shows you how to record a voc-file    
    from CD or Mikrofophone                             
    It also uses some Mixer Functions, that are         
    only available for SbPRO owners. Time to upgrade !  
  */


  FUNCTION SbRecord ()

     LOCAL oRecWin, oCdWin, nX, nY, nKey, Getlist := {}

     LOCAL nEvent := EVENT_INIT

     LOCAL oL, oR, aVolume [2], aOrgVol

     LOCAL aSource := {'Disc',;
                       'Mikro',;
                       'Line     ' }

     LOCAL aFilter := {'Low',;
                       'High',;
                       'None   ' }

     LOCAL nKanal := CH_CD, nInKanal := 1, nFilter := 3


     LOCAL nSample := 10000, nLength := 20, lStereo := .F.

     LOCAL cFile := 'TestaVoc.voc'

     LOCAL nTrack := GetTrackCd(0), nOffset

     LOCAL InBut :=  {'Start ~Recording', '~Cancel' }

     LOCAL OutBut := {'~Stop Recording ', '~FadeOut' }

     LOCAL nChoice := 2, lRecord := .f., oButton


     CREATE WINDOW oRecWin ;
            FROM 1,10 TO 22,68 ;
            TITLE 'SBPRO-TRICORDER' ;
            TOPCOLOR 47 ;
            WINCOLOR F_NBEIGE ;
            TYP WIN_MESSHELP

     SETCOLOR  ( STD_INFO )



     /* Mainloop
        ======== */
     DO WHILE nEvent # EVENT_EXIT

        DO CASE

        CASE nEvent == EVENT_INIT
      /*---------------------------*/

           // Create ScrollBarObjects
           oL := ScrollBar():New ( 2,  5, 18, .f., 0):Show()
           oR := ScrollBar():New ( 2,  9, 18, .f., 0):Show()

           // Create ButtonObject
           oButton := oAddButt ( 16, 17, F_NW, F_RW, InBut , .f. )


           // Scala
           FOR nX := 3 TO 17
               Hlinie (nX,7,9)
           NEXT


           // Build Init Screen
           // -----------------
           DISPBOX ( 2,13,18,55 )
           @  2, 16 SAY ' Parameters '


           @  5, 17 GET nInKanal ;
                    AS RADIOBUTTON aSource  ;
                    COLOR          F_NBEIGE ;
                    SHORTCUT ALT-D, ALT-M, ALT-L ;
                    DESCRIBE "Select Input Channel" ;
                    HOTKEY         F_RBEIGE ;
                    FRAME

           @  4, 17 SAY 'Input Channel'

           @  5, 37 GET nFilter;
                    AS RADIOBUTTON aFilter  ;
                    SHORTCUT ALT-L, ALT-H, ALT-N ;
                    DESCRIBE "Select Input Filter" ;
                    COLOR F_NBEIGE ;
                    HOTKEY F_RBEIGE ;
                    FRAME

           @  4, 37 SAY 'Input Filter'


           @ 11, 17 GET lStereo ;
                    AS CHECKBOX '~Stereo  ?'   ;
                    INITIAL .T.  ;
                    COLOR F_NBEIGE ;
                    HOTKEY F_RBEIGE ;
                    SHORTCUT ALT-S  ;
                    DESCRIBE "Space : ~Stereo - Recording ?"


           @  9, 37 GET  nSample ;
                    AS SPINNER INITIAL 10000 ;
                    FRAME IN F_NW ALWAYS ;
                    RANGE FROM 4000 TO 24000 ;
                    PICTURE '99999' ;
                    PROMPT ABOVE '~Sample Rate :' HOTKEY F_RBEIGE ;
                    DESCRIBE "Valid Sample Rates are 4000 - 24000" ;
                    SHORTCUT ALT-R


           @ 13, 17 GET  cFile ;
                    AS FRAME IN F_NW PICT '@K' ;
                    ALWAYS ;
                    PROMPT ABOVE '~FileName :' HOTKEY F_RBEIGE ;
                    DESCRIBE "Filename for recorded Sounddata" ;
                    SHORTCUT ALT-F

           @ 13, 37 GET  nLength ;
                    AS SPINNER INITIAL 20 ;
                    FRAME IN F_NW  ALWAYS ;
                    PICTURE '999' ;
                    PROMPT ABOVE 'File~Blocks :' HOTKEY F_RBEIGE ;
                    DESCRIBE "Enter 0 for unlimited recording" ;
                    SHORTCUT ALT-B



           READ


           IF LASTKEY() == K_ESC
              nEvent := EVENT_EXIT
              LOOP
           ENDIF


           // Init CD for recording //
           IF nInKanal == 1

              IF InitCd() == 0
                 AlertBox (2, 'Kein CD-Player !',{'~OK'})
                 LOOP

              ENDIF

              CREATE WINDOW oCdWin ;
                     FROM 11,15 to 17,63 title 'Prepare CD'  ;
                     topcolor F_WBROWN wincolor F_NBEIGE    ;
                     typ WIN_MESSAGE


              @  2, 3  GET  nTrack AS SPINNER ;
                       FRAME IN F_NW ;
                       PICTURE '99' ;
                       RANGE FROM 1 TO GetTrackCd (2) ;
                       PROMPT "Which ~Track shall be recorded ?" ;
                       HOTKEY F_RBEIGE SHORTCUT ALT-T

              @  4, 3  GET  nOffset AS SPINNER ;
                       INITIAL 0 ;
                       FRAME IN F_NW ;
                       PICTURE '999' ;
                       PROMPT "~Offset in Seconds from start ? " ;
                       HOTKEY F_RBEIGE SHORTCUT ALT-O


              READ
              CLOSE WINDOW oCdWin

              IF LASTKEY() == K_ESC
                 nEvent := EVENT_EXIT
                 LOOP
              ENDIF
              nKanal := CH_CD

           ELSE
              nKanal := IIF( nInKanal == 2, CH_MIC, CH_LINE )

           ENDIF


         /* Set Input Volume to 'Full Throttle' */
           aOrgVol := GetSbVol ( nKanal )
           SetSbVol( nKanal, {15, 15} )

         /* Set Input Channel ( default = CD ) */
           RecSource ( IIF( nInKanal == 0, CH_IN_CD, nInKanal ))

         /* Set Input Filter */
           RecFilter( (nFilter # 3), (nFilter == 2) )

         /* Kill Input Screen */
           scroll ( 3,14,17,54,0 )

           @  2, 16 SAY ' Recording  '

           @  4, 16 SAY 'Input Channel:'
                    Outline ( 6, 16,  TRIM( aSource [nInKanal])+ ;
                    IIF(nKanal == CH_CD,' Track '+STR(nTrack,2),''),2, F_NW)

           @  4, 36 SAY 'Input Filter :'
                    Outline ( 6, 36, TRIM( aFilter [nFilter]), 2, F_NW )


         /* Display FileParameters */
           @  8, 16 SAY 'FileName:'
           Outline (10, 16, cFile, 2, F_NW )

         /* Show FileSize */
           @  8, 36 SAY 'Recorded bytes:'

         /* Display Button Object */
           oDisButt ( oButton,  nChoice )

           nEvent := EVENT_UPDATE


        CASE nEvent == EVENT_UPDATE
       //---------------------------

             MSE_SHOW (.t.)
             DISPBEGIN()

            /* Read Mixer Registers */
             aVolume  := GetSbVol ( nKanal )


            /* Set Scrollthump */
             oL:SetPos ( 17 - aVolume[1] )
             oR:SetPos ( 17 - aVolume[2] )

            /* Show FileSize */
             Outline (10, 36, Str( VocRecSize(), 8), 2, F_NW )

             nEvent := IIF (lRecord .AND. ! PlayActiv(), ;
                                         EVENT_EXIT, EVENT_INKEY )

             MSE_SHOW(.F.)
             DISPEND()


        CASE nEvent == EVENT_RECORD
       /*---------------------------*/

          /* Start Track from CD ?? */
            IF nKanal == CH_CD

               PlayCd ( nTrack, nOffset, -1 )

            ENDIF


           /* Display Button Object */
           oButton := oAddButt ( 16, 17, F_NW, F_RW, OutBut, .f. )
           oDisButt ( oButton , 2 )
           lRecord := .t.

           // let's twist again
           RecVoc( cFile, nSample, nLength, lStereo )


           nEvent := EVENT_UPDATE



        CASE nEvent == EVENT_INKEY
        /*------------------------*/
            nKey := KeyReader (nil,.5)
            nEvent := EVENT_UPDATE

            IF nKey == 0
               nEvent := EVENT_UPDATE

            ELSEIF nKey == K_MOUSE

               IF ( nX := oMouseButt( oButton)) # nil
                    nChoice := oSetFocus ( oButton, nX )
                    nEvent  := EVENT_BUTTON

               ENDIF

            ELSE


           /* Mouse is done, look for Key's
             ============================= */
            DO CASE

                  // HotKey ?


                CASE nKey == K_LEFT  .OR. nKey == K_DOWN .OR. ;
                     nKey == K_RIGHT .OR. nKey == K_UP

                     nChoice := oSetFocus ( oButton, WrapWert          ;
                                   ( nKey == K_RIGHT .OR. nKey == K_UP,;
                                          nChoice, 1, 2 ))

                CASE nKey == K_HOME
                     nChoice := oSetFocus ( oButton, 1 )


                CASE nKey == K_END
                     nChoice := oSetFocus ( oButton, 2 )


                CASE LASTKEY() == K_ESC
                     nChoice := oSetFocus ( oButton, 1 )
                     nEvent :=  EVENT_BUTTON

                CASE nKey == K_ENTER
                     nEvent :=  EVENT_BUTTON

                CASE (nX := oKeyButt ( oButton, nKey )) # nil
                      nChoice := oSetFocus ( oButton, nX )
                      nEvent  := EVENT_BUTTON

             ENDCASE

            ENDIF
        CASE nEvent == EVENT_BUTTON
        /*------------------------*/
             nChoice := oPushButt ( oButton )
             nEvent := EVENT_EXIT

          // Check for Action
             DO CASE

             // Stop Recording ?
             CASE nChoice == 1 .AND. lRecord
                  PlayStop()

             CASE nChoice == 2 .AND. lRecord
                  FadeVoc ( nKanal, 4 )
                  nEvent := EVENT_UPDATE

             // Start Recording
             CASE nChoice == 1 .AND. ! lRecord
                  nEvent := EVENT_RECORD

             ENDCASE


        ENDCASE

     ENDDO

     PlayStop()
     StopCd()
     ExitCd()

     CLOSE WINDOW oRecWin

     IF ! (aOrgVol == nil)
          SetSbVol( nKanal, aOrgVol)
     ENDIF


  RETURN .t.

  /* SbRecord ENDP */
