 /*
 
 								         
       SoundVis.ch  Copyright (c) Tom Groeger 1994                     
       Version   :  2.06 TEN-FORWARD    All rights reserved            
       Created   :  15.08.93                                           
       Modified  :  02.04.95                                           
       Code type :  Include File for Sound & Vision                    
       Section   :  General Definition File                            
 								         
 
 */

/* What Version of Clipper are we using ? */
#ifdef _SET_CH
  #define CLIPPER52
  #stdout Include Sound & Vision /CL5.20

#else
  #define CLIPPER50

  #define K_CTRL_UP         397   // * Ctrl-Up arrow
  #define K_CTRL_DOWN       401   // * Ctrl-Down arrow
  #define K_SPACE            32   // * Spacebar

#endif


/* Extended INKEY - CODES */
#define   K_ALT_SEP        386         // Alt '-' - Activate SysMenu


/* Extended KeyStatus */
#define   IS_INSERT          7
#define   IS_CAPSLOCK        6
#define   IS_NUMLOCK         5
#define   IS_SCROLLLOCK      4
#define   IS_ALTKEY          3
#define   IS_CTRLKEY         2
#define   IS_LEFTSHIFT       1
#define   IS_RIGHTSHIFT      0


// definitions

#define   A_SANDGLASS      ''          // 189
#define   A_LU             ''          // 212
#define   A_RU             ''          // 211
#define   A_UPPER          ''          // 199
#define   A_BOTTOM         ''          // 200
#define   A_SEP            ''          // 196


// ICON - Constants for DrawIcon()
#define   CLOSE_ICON         0
#define   MOVE_ICON          1
#define   WAHL_ICON          2
#define   LEFT_ICON          3
#define   RIGHT_ICON         4
#define   UP_ICON            5
#define   DOWN_ICON          6
#define   VERTBAR_ICON       7
#define   HORBAR_ICON        8
#define   BOX_ICON           9
#define   ECK_ICON          10
#define   BOXO_ICON         11
#define   BOXU_ICON         12



// Constants for EventStatus-Array
#define  E_MROW              1         // nMseRow
#define  E_MCOL              2         // nMseCol
#define  E_BUTTON            3         // nMouseButtonPressed
#define  E_DOUBLE            4         // Is lDoubleKlick
#define  E_ALT               5         // Is lAltKey
#define  E_SCROLL            6         // Is lScrollLockKey
#define  E_CROW              7         // nCursorRow
#define  E_CCOL              8         // nCursorCol
#define  E_SENDER            9         // oSenderObj
#define  E_WROW             10         // WindowTopRow
#define  E_WCOL             11         // WindowTopCol
#define  E_WBOTROW          12         // WindowBotRow
#define  E_WBOTCOL          13         // WindowBotCol
#define  E_CARGO            14         // EventCargo
#define  E_EVLEN            14         // Arraylen

// Return values of the menu functions

#define   B_ESC              0
#define   B_LEFT            -1
#define   B_RIGHT           -2
#define   B_QUIT            -3
#define   B_SKIP            -5

/* Window Event Messages */
#define WINMSG_OPEN          1
#define WINMSG_CLOSE         2
#define WINMSG_HIDE          3
#define WINMSG_MOVE          4
#define WINMSG_SIZE          5

/* Menu ExitStates */
#define EXIT_NONE            0
#define EXIT_ALL             1
#define EXIT_POPUP           2
#define EXIT_ALLPOPUP        3

/* KeyHandler Caller */
#define IS_GET               1
#define IS_MENU              2
#define IS_TB                3



/* Event MsgIds */

#define   M_NOMATCH          0      // Nothing found
#define   M_HITWIN           1      // Mouse hits Windowrect
#define   M_RECEIVED         2      // Key/MouseEvent proceeded
#define   M_EXITREADER       3      // Key/MouseEvent proceeded, exit reader
#define   M_DISABLED         4      // Found but can't activate
#define   M_CLOSE          248      // Mouse hits CloseButton
#define   M_MOVE           254      //  "         MoveButton
#define   M_CHOICE         253      //  "         ChoiceButton
#define   M_WAHL           253      //  "
#define   M_UP             252      // Mouse hits Scrollbar    Top
#define   M_DOWN           251      //  "                   Bottom
#define   M_LEFT           250      //  "                     Left
#define   M_RIGHT          249      //  "                    Right
#define   K_MOUSE          255      // MouseButton Id
#define   M_SCROLLGOHOME   300      // go Top request
#define   M_SCROLLGOEND    301      // go End request
#define   M_SCROLLGOTO     302      // position request
#define   M_SCROLLUP       303      // scrollup request
#define   M_SCROLLDOWN     304      // scrolldown request


/* ArrayDimension for MouseArray  */
#define   MSE_TROW           1      // Upper MouseRow
#define   MSE_LCOL           2      // Left  MouseCol
#define   MSE_BROW           3      // Lower MousRow
#define   MSE_RCOL           4      // Right MouseRow
#define   MSE_RET            5      // Return value/Function

/* WindowConstants  / Types of Windows */
#define   WIN_SINGLE         0      // single frame
#define   WIN_GSINGLE       32      // Grafic frame
#define   WIN_GSINGBUT      64      // Grafic frame, spaces below
#define   WIN_MESSAGE       51      // GrafWindow with Close/Movebutton
#define   WIN_LIST         187      // ListBox with ScrollBar without menue
#define   WIN_FULL         191      // full Window: everything's in here
#define   WIN_MESSBUT       83      // MessageBox without underline
#define   WIN_LISTBOX      160      // Listbox with vertikal Scroller
#define   WIN_LISTHELP     443      // Listbox/Scrollbar/Helpline
#define   WIN_MESSHELP     307      // MesssageBox with Helpline


/* MessageBox - Types */
#define   MB_QUESTION    0      // single frame
#define   MB_EXCLAMATION 1      // Grafic frame
#define   MB_NOICON      2      // Grafic frame, spaces below

/* Colordefinition for SetDAC ColorValue */
#define   C_N                0      // black
#define   C_B                1      // blue
#define   C_G                2      // green
#define   C_BG               3      // cyan
#define   C_R                4      // red
#define   C_RB               5      // magenta
#define   C_RG               6      // brown
#define   C_W                7      // white
#define   C_HN               8      // grey
#define   C_HB               9      // shining blue
#define   C_HG              10      // shining green
#define   C_HBG             11      // light blue
#define   C_HR              12      // shining red
#define   C_HRB             13      // shining magenta
#define   C_HRG             14      // yellow
#define   C_HW              15      // shining white


/* SBPro - Mixer */
#define   CH_MASTER          0      // Master-Volume
#define   CH_VOICE           1      // Vocplayer
#define   CH_FM              2      // FmPlayer
#define   CH_CD              3      // Audio-CD
#define   CH_LINE            4      // Line In
#define   CH_MIC             5      // Mikrophone

#define   CH_IN_CD           1      // Input Channel = CD
#define   CH_IN_MIKRO        2      // Input Channel = Mikrophone
#define   CH_IN_LINE         3      // Input Channel =
#define   CH_HIFILTER       .t.     // Recordfilter = High
#define   CH_LOFILTER       .f.     // Recordfilter = Low


/* ColorDefinitions for SetLibCol
  -------------------------------- */
#define   C_BARCOL        1 // MenuBar,     default 240 -  black on white+
#define   C_BARKEY        2 // Hotkey               244 -  red on white+
#define   C_BARPASSIV     3 // non-chooseable       248 -  grey on white+
#define   C_BARPROMPT     4 // PromptColor           15 -  +white on black
#define   C_BARHOTKEY     5 // HotKeyColor           15 -  +white on black

/* PopUp-Menu
 ------------- */
#define   C_POPCOL        6 // Window/Text           48 -  black on light blue
#define   C_POPKEY        7 // Hotkeys               52 -  red on light blue
#define   C_POPPASSIV     8 // Choice not available  56 -  grey on light blue
#define   C_POPPROMPT     9 // Prompt                15 -  light white on black
#define   C_POPHOTKEY    10 // Prompt-Hotkey         10 -  light green on black
#define   C_POPSHORT     11 // ShortCuts in Menu     55 -  white on light blue

/* ColorDefinitions for Windows
 ------------------------------- */
#define   C_MASKWIN      12 // Window/FrameColor    112 -  black on white
#define   C_MASKMENU     13 // MenuBar              240 -  black on white+
#define   C_MASKHEAD     14 // Title                 31 -  +white on blue
#define   C_MASKSYMB     15 // All Icons              7 -  white on black

/* AlertBoxes: TitleColor
 ------------------------ */
#define   C_BOXHEADER    16 // TitleColor           112 -  black on white
#define   C_BOXICONS     17 // Alertboxes' Icon Color 112

/* Question ? - Box
 ------------------- */
#define   C_QUESTWIN     18 // QuestionBox           23 -  white on blue
#define   C_QUESTTEXT    19 // Text                  30 -  yellow on blue
#define   C_QUESTBUTTEXT 20 // ButtonText           112 -  black on white
#define   C_QUESTBUTHOT  21 // ButtonHotkey         116 -  red on white

/* Attention ! - Box
 -------------------- */
#define   C_ALERTWIN     22 // AlertBox              71 -  white on red
#define   C_ALERTTEXT    23 // MessageText           69 -  yellow on red
#define   C_ALERTBUTTEXT 24 // ButtonText            46 -  yellow on green
#define   C_ALERTBUTHOT  25 // ButtonHotkey          44 -  red on green

// Message-Box
#define   C_MESSWIN      26 //  MessageBox          208 -  black on purple
#define   C_MESSTEXT     27 //  MessageText         212 -    red on purple
#define   C_MESSBUTTEXT  28 //  Button-Text         112 -  black on white
#define   C_MESSBUTHOT   29 //  Button-Hotkey       116 -    red on white

// Descript() - Row
#define   C_DESCROW      30 // DispText-Row          24 - Row 24
#define   C_DESCCOL      31 // DispText-Column       01 - Col 1
#define   C_DESCEND      32 // EndColumn             79 - EndCol 79

// Button-Preferences
#define   C_GRAFBUTTON   33 // GraficButtons  1 = Yes  2 = No
#define   C_BUTTUPPER    34 // Upper Buttonline   chr(200)
#define   C_BUTTOBEN     34 // Compat.
#define   C_BUTTLOWER    35 // Lower Buttonline   chr(199)
#define   C_BUTTUNTEN    35 // Compat.
#define   C_BUTTTEXT     36 // Default Button - Color
#define   C_BUTTHOT      37 // Default Button - HotKeyColor
#define   C_CTRLHOT      38 // Default Radio/CheckBox HotKeyColor

//Cursor-Preferences
#define   C_CURSINSERT   39 // Default Insert-Cursor
#define   C_CURSDELETE   40 // Default Delete-Cursor

// ErrorBox
#define   C_NOALERT      41 // Alertbox at DOS-Errors  1 = Yes ( def) 2 = No


// Just a few tricks, using the PreProcessor :
// -------------------------------------------

#ifndef DEFAULT

  // Default Varible to Value
  #command    DEFAULT <var> TO <val> [ , <varN> TO <valN> ]  ;
                 => ;
                 IF <var>  == NIL; <var>  := <val>;  END ;
              [; IF <varN> == NIL; <varN> := <valN>; END]
#endif

  #command IF <clause> {<result>};
                 => ;
                 IF<clause>;<result>;END

// Define Standard CodeBlocks
// -------------------------------------
#xtranslate bDummy       =>  { || .T. }
#xtranslate bGet(<var>)  =>  { |val| IIF(PCOUNT()==0,<var>,<var> := val)}


// New Commands
// ------------

#xcommand @ <row>, <col> GET <var> AS PUSHBUTTON <aPush>     ;
                         [INITIAL <nInit>]                   ;
                         [SHORTCUT <cCut> [,<cCutN>]]        ;
                         [COLOR  <nCol>]                     ;
                         [HOTKEY <nHot>]                     ;
                         [TIMEOUT <nSec>]                    ;
                         [DESCRIBE <cHlp>]                   ;
                         [<vert: VERTIKAL>]                  ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
                         [ACTION <bAction>]                  ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD( getlist, PushButton():New(                   ;
            _GET_( <var>, <(var)>,, <{valid}>, <{when}>),    ;
               <nCol>, <nHot>, <nSec>, <cHlp>,<aPush>,       ;
                 <.vert.>, <nInit>, \{#<cCut> [,#<cCutN>]\}, ;
                      <bAction>):Display())

#xcommand @ <row>, <col> GET <var> AS RADIOBUTTON <aRadio>   ;
                         [INITIAL <nInit>]                   ;
                         [SHORTCUT <cCut> [,<cCutN>]]        ;
                         [COLOR  <xCol>]                     ;
                         [HOTKEY <xHot>]                     ;
                         [DESCRIBE <cHlp>]                   ;
                         [<frame: FRAME>]                    ;
                         [<hori: HORIZONTAL>]                ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
                         [ACTION <bAction>]                  ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD( getlist, RadioBut():New(                     ;
            _GET_( <var>, <(var)>,'x', <{valid}>, <{when}>), ;
               <xCol>,<xHot>, <cHlp>, <aRadio>, <.hori.>,    ;
                 <.frame.>, <nInit>, \{#<cCut> [,#<cCutN>]\},;
                     <bAction>):Display())



#xcommand @ <row>, <col> GET <var> AS CHECKBOX <cTxt>        ;
                         [INITIAL <linit>]                   ;
                         [SHORTCUT <cCut> [,<cCutN>]]        ;
                         [COLOR  <ncol>]                     ;
                         [HOTKEY <nhot>]                     ;
                         [DESCRIBE <chlp>]                   ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
                         [ACTION <bAction>]                  ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD(getlist,CheckBox():New (                      ;
            _GET_( <var>, <(var)>,, <{valid}>, <{when}>),    ;
               <ncol>, <nhot>, <chlp>, <cTxt>, <linit>,      ;
                 \{#<cCut> [,#<cCutN>]\},<bAction>):Display())



#xcommand @ <row>, <col> GET <var> AS LISTBOX <aLst>         ;
                           [INITIAL <nInit>]                 ;
                           [FRAME IN <col1> [,<col2>]]       ;
                           [<lkill: ALWAYS>]                 ;
                           [SHORTCUT <cCut> [,<cCutN>]]      ;
                           [PROMPT [<lUp: ABOVE>] <cPrompt>] ;
                           [HOTKEY <nHot>]                   ;
                           [DESCRIBE <chlp>]                 ;
                           [PICTURE <cPic>]                  ;
                           [VALID <valid>]                   ;
                           [WHEN <when>]                     ;
            => ;
          SetPos( <row>, <col> ) ;;
          AADD (getlist,GetExt():ListBox (                   ;
         _GET_( <var>, <(var)>, <cPic>, <{valid}>, <{when}>),;
               <nInit>,<aLst>,<col1>,\{#<cCut>\},            ;
                 <cPrompt>, <.lUp.>,<nHot>,<chlp>,<.lkill.>):Display())


#xcommand @ <row>, <col> GET <var> AS SPINNER                ;
                         [INITIAL <nInit>]                   ;
                         [RANGE FROM <min> TO <max>]         ;
                         [LIST <aLst>]                       ;
                         [FRAME IN <col1> [,<col2>]]         ;
                         [<lkill: ALWAYS>]                   ;
                         [SHORTCUT <cCut>]                   ;
                         [PROMPT [<lUp: ABOVE>] <cPrompt>]   ;
                         [HOTKEY <nHot>]                     ;
                         [DESCRIBE <cHlp>]                   ;
                         [PICTURE <cPic>]                    ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD (getlist,GetExt():SpinBox (                   ;
         _GET_( <var>, <(var)>, <cPic>, <{valid}>, <{when}>),;
             <nInit>,<aLst>,<col1>,\{#<cCut>\},<cPrompt>,    ;
               <.lUp.>,<nHot>,<cHlp>,<min>,<max>,            ;
                  <.lkill.>):display())


#command  @ <row>, <col> GET <var> AS FRAME                  ;
                         [IN <col1> [,<col2>]]               ;
                         [<lkill: ALWAYS>]                   ;
                         [SHORTCUT <cCut>]                   ;
                         [PROMPT [<lUp: ABOVE>] <cPrompt>]   ;
                         [HOTKEY <nHot>]                     ;
                         [DESCRIBE <cHlp>]                   ;
                         [PICTURE <cPic>]                    ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD(getlist,GetExt():GetFrame (                   ;
         _GET_( <var>, <(var)>, <cPic>, <{valid}>, <{when}>),;
            <col1>,\{#<cCut>\}, <cPrompt>, <.lUp.>,<nHot>,   ;
                 <cHlp>,<.lkill.>,.T.):display())


#command  @ <row>, <col> GET <var> AS TEXT                   ;
                         [SHORTCUT <cCut>]                   ;
                         [PROMPT [<lUp: ABOVE>] <cPrompt>]   ;
                         [HOTKEY <nHot>]                     ;
                         [DESCRIBE <cHlp>]                   ;
                         [PICTURE <cPic>]                    ;
                         [VALID <valid>]                     ;
                         [WHEN <when>]                       ;
          => ;
          SetPos( <row>, <col> ) ;;
          AADD(getlist,GetExt():GetFrame (                   ;
         _GET_( <var>, <(var)>, <cPic>, <{valid}>, <{when}>),;
               nil,\{#<cCut>\}, <cPrompt>, <.lUp.>,<nHot>,   ;
                 <cHlp>, .F.,.F.):display())

/* Define ModalWindow
  -------------------- */
#xcommand OPENWIN FROM <tRow>, <tCol> TO <bRow>, <bCol>      ;
                  [TITLE <title>]                            ;
                  [TOPCOLOR <TClr>]                          ;
                  [WINCOLOR <WClr>]                          ;
                  [TYP <typ>]                                ;
                  [<x: SAVE TO, HANDLE> <Handle> ]           ;
                  => ;
          [<Handle> :=] OpenMask  (<tRow>,<tCol>,<bRow>,<bCol>,;
                                    <title>,<typ>,<TClr>,<WClr>)


#xcommand CLOSEWIN <Handle> => ScrRest (<Handle>)


#define  SECWINDOW 1
#define  POPUPWIN  2
#define  PRIMEWIN  3


/* Create WindowObj
  ------------------ */
#xcommand CREATE WINDOW <oWnd>                               ;
                 FROM   <top>,<left> TO <bot>, <right>       ;
                [TITLE <title>]                              ;
                [TOPCOLOR <tclr>]                            ;
                [WINCOLOR <wclr>]                            ;
                [TYP <typ>]                                  ;
                [<shad: NOSHADOW>]                           ;
                [GROUP <nGp>]                                ;
                [ACTION <bAction>]                           ;
                [EVENT  <bEvent>]                            ;
                => ;
         <oWnd> := Window():New(<top>,<left>,<bot>,<right>,  ;
               <title>,<tclr>,<wclr>,<typ>,!<.shad.>,<nGp>,  ;
                      <bAction>,<bEvent>):Open()

/* Set controls to windowObj
 ---------------------------- */
#xcommand ATTACH CONTROLS TO <oWnd> ;
                [START AT <nGet>] ;
                => ;
                <oWnd>:getControl(getlist,<nGet>) ;
              ; getlist  := {}

#xcommand ATTACH MENU <aMen> TO <oWnd> ;
                => ;
                <oWnd>:getMenu(<aMen>) ;
              ; <aMen> := nil

#xcommand ATTACH TBROWSE <oTb> TO <oWnd> ;
                => ;
                <oWnd>:Tb := <oTb>

/* Activate Window
  ----------------- */
#xcommand ACTIVATE WINDOW <oWnd> ;
                  [INITIAL <nIni>] ;
                  [TITLE <cTitle>] ;
                  [TO <xRet>] ;
                   => ;
                  [<xRet>:=] <oWnd>:Activate(<nIni>,<cTitle>)

/* DeActivate Window
  ------------------- */
#xcommand HIDE WINDOW <oWnd> ;
                => ;
                <oWnd>:Hide()

/* Kill Window */
#xcommand CLOSE WINDOW <oWnd> ;
                => ;
                <oWnd> := <oWnd>:Close()


/* WinSay with colored Hotkey */
#command @ <row>,<col> OUT <text> ;
                 [<of:OF,TO,IN,WINDOW> <oWin>] ;
                 [COLOR <cCol>,<hCol>] ;
                 => ;
                 sayHot(<row>,<col>,<text>,<hCol>,<cCol>,<oWin>)


/* Define TBrowse
  ---------------- */
#xcommand BROWSE TABLE                                       ;
                 [RECORD <rec>]                              ;
                 [FROM <nTop>,<nLeft> TO <nBottom>,<nRight>] ;
                 [TITLE <cTitle>]                            ;
                 [FIELDS <aFields>]                          ;
                 [FOR <bScope>]                              ;
          => ;
          [<rec>:=] DbfBrowse (<nTop>, <nLeft>, <nBottom>,   ;
                  <nRight>, <{bScope}>, <aFields>, <cTitle>)


/* Define Menu
  -------------- */
#xcommand ADDITEM <aMen>                                     ;
                 [PROMPT <Label>]                            ;
                 [<x: CHOICE, ACTION, POPUP> <Action>]       ;
                 [SHORTCUT <cShort>]                         ;
                 [<lSel: DISABLED>]                          ;
                 [HELP <ctxt>]                               ;
                 [HANDLE <Handle>]                           ;
                 [AT <nOff>]                                 ;
                 [<cCheck: CHECKED,UNCHECKED>]               ;
          => ;
          aadd(<aMen>, ( [<Handle> :=] MenuItem():New(       ;
                          <nOff>,<Label>,<Action>,!<.lSel.>, ;
                            <ctxt>, <cShort>,<"cCheck"> )))  ;

#xcommand ADDSEP <aMen>                                      ;
          => ;
          aadd(<aMen>, MenuItem():New(,A_SEP,,.F.))


#xcommand INIT MENU <oMen> FROM <aMen>                       ;
          [AT <row>, <col>]                                  ;
          [MOUSEHANDLER  <bMse>]                             ;
          [ESCAPEHANDLER <bEsc>]                             ;
          => ;
          <oMen> := Menu():New(<row>,<col>,                  ;
                      MenuSys():New(<aMen>),<bEsc>,<bMse>)

#xcommand MENU <oMen> TO <xRet>                              ;
          [PROMPT <start>]                                   ;
          => ;
          [<xRet> :=] <oMen>:StartMain(<start>)



// Define Commands for the Event Engine
// -------------------------------------
#translate THISEVENT ([<handle>]) => SV_F059(<handle>,0)
#command   KILLEVENT (<handle>)   => SV_F059(<handle>,1)
#command   PAUSEEVENT (<handle>)  => SV_F059(<handle>,2)
#command   RESUMEEVENT (<handle>) => SV_F059(<handle>,3)

#command  NEWEVENT [IS <nHandle>] EVERY <nTick> TICKS CALL <cProz> ;
          => ;
          [<nHandle> :=] SV_F058 ( 0, <nTick>, <"cProz">)

#command  NEWEVENT [IS <nHandle>] AT <nTick> TICKS CALL <cProz> ;
          => ;
          [<nHandle> :=] SV_F058 ( 1, <nTick>, <"cProz">)

#command  DEFINE EVENT <*para*> => FUNCTION <para>




