 /*
 
 								         
       Title     :  svEngine.ch    Copyright (c) Tom Groeger 1994      
       Version   :  2.05 TEN-FORWARD                                   
       Created   :  03/02/94                                           
       Modified  :  10/06/94                                           
       Code type :  Include File for Sound & Vision                    
       Section   :  :oEngine                                           
 								         
 
 */



#xcommand   EXPORT:                                   =>  __insScope ( 0 )
#xcommand   PROTECT:                                  =>  __insScope ( 1 )
#xcommand   HIDDEN:                                   =>  __insScope ( 2 )
#xcommand   LOCAL:                                    =>  HIDDEN:
#xcommand   EXPORTED:                                 =>  EXPORT:
#xcommand   READONLY:                                 =>  PROTECT:
#xcommand   PROTECTED:                                =>  PROTECT:

#xtranslate __STATUS__                                => nil
#xtranslate __STATUS__ <ass: EXPORTED >               => 0
#xtranslate __STATUS__ <ass: RO, READONLY, PROTECTED> => 1
#xtranslate __STATUS__ <ass: HIDDEN, LOCAL >          => 2

#xtranslate __SHARED__                                => nil
#xtranslate __SHARED__ <shd: SHARED>                  => 4

#xtranslate __TYPE__                                  => nil
#xtranslate __TYPE__   <typ: NUM>                     => 16
#xtranslate __TYPE__   <typ: DATE>                    => 32
#xtranslate __TYPE__   <typ: LOG, BOOL>               => 48
#xtranslate __TYPE__   <typ: CHAR, STRING>            => 64
#xtranslate __TYPE__   <typ: BLOCK, CODE>             => 80
#xtranslate __TYPE__   <typ: ARRAY, OBJECT>           => 96



#xtranslate __DBLE__   (<p1>,<p2>)                     => <p1>
#xtranslate __DBLE__   (<p1>)                          => <p1>
#xtranslate __GETNAME__(<init>([<formals,...>])[()],[<name>]([<para,...>]));
               => ;
               QSELF():super:__DBLE__([<name>,] <init>)(<para>)

#xtranslate  ::                        => self:
#xtranslate  self:super:               => qself():super:
#xtranslate  @:<udf>([<arg>][,<argN>]) => <udf>(_HashSelf(<arg>)[,<argN>])

/*
    CREATE CLASS .. FROM ..     Define new Class
    .. END CLASS                ...  Build Class
   [DEFINE] METHOD              Define new Method
   CLASS   METHOD               Define new Class Method
*/

#xcommand CREATE CLASS <name> ;
               [ <from: FROM, INHERIT FROM, INHERIT, OF> <parent> ] ;
               => ;
               FUNCTION <name> ;;
               STATIC Self ;;
               IF Self == nil ;;
                   __DefineObj (<"name"> [,<parent>()]) ;
                   ; #include "SVMETHOD.CH"


#xcommand END CLASS ;
               => ;
                  Self := __MakeClass() ;;
               end ;;
               RETURN Self ;
               ; #include "SVMETHOD.CH"


#command __METHOD <para>, <superPara> ;
               => ;
               STATIC FUNCTION <para> ;;
                LOCAL self := (__GETNAME__(<para>(),<superPara>),ISELF())

#xcommand __METHOD <para> ;
               => ;
               STATIC FUNCTION <para> ;;
               LOCAL self := ISELF()


#xcommand PUBLIC METHOD <para> ;
               => ;
               FUNCTION <para> ;;
                LOCAL self := ISELF()


#xcommand CLASS METHOD <*formals*> ;
               => ;
               __METHOD <formals>


#xcommand SELFLESS METHOD <*formals*> ;
               => ;
               STATIC FUNCTION <formals>


#xcommand DEFINE CLASS METHOD <*more*> => CLASS METHOD <*more*>
#xcommand DEFINE METHOD <*more*>       => METHOD <more>
#xcommand ENDCLASS                     => END CLASS


/*
    VAR xx AS xx INIT xy SCOPE xz declare Instance Variable
    CLASS VAR   ""                declare Class Variable
    VAR xx SETGET xx              declare SetGet Method
*/

#xcommand VAR   <var1> [,<varN>] ;
                [ AS <typ: NUM,DATE,LOG,BOOL,CHAR,STRING,BLOCK,CODE,ARRAY,OBJECT>] ;
                [ <def: DEFAULT, INIT, ORG> <value> ] ;
                [ <ass: RO, READONLY, HIDDEN, LOCAL, PROTECTED, EXPORTED>] ;
                => ;
                __InsVar(.F.,\{#<var1> [,#<varN>]\},;
                           [<value>],[__STATUS__ <ass>],;
                                     [ __TYPE__  <typ>] )


#xcommand CLASS VAR <var1> [,<varN>] ;
                [ AS <typ: NUM,DATE,LOG,BOOL,CHAR,STRING,BLOCK,CODE,ARRAY,OBJECT>] ;
                [ <def: DEFAULT, INIT, ORG> <value> ] ;
                [ <ass: RO, READONLY, HIDDEN, LOCAL, PROTECTED, EXPORTED>] ;
                [ <shd: SHARED>] ;
                => ;
                __InsVar(.T.,\{#<var1> [,#<varN>]\},;
                           [<value>],[__STATUS__ <ass>],;
                                     [ __TYPE__  <typ>],;
                                     [ __SHARED__ <shd>] )

#xcommand VAR <mess> SETGET <met> ;
               => ;
               __InsMet ( .F.,     <(mess)>, {||<met>()}) ;;
               __InsMet ( .F., "_"+<(mess)>, {||<met>()})


/*
    METHOD ...                  declare Method
    METHOD ... = ..             declare Method ..
    METHOD ... MESSAGE ..        .. with Message
    METHOD ... VIRTUAL          declare Dummy Message
    METHOD ... DEFERRED         declare Deferred Messages

*/

#xcommand _METHOD_ <(mess)> [,<*messN*>] ;
               => ;
               __InsMet(.F.,<(mess)>,{||<mess>()}) [; _METHOD_ <messN>]

#xcommand METHOD  <met> MESSAGE <(mess)> ;
               => ;
               __InsMet(.F.,<(mess)>,{||<met>()})


#xcommand MESSAGE <(mess)> METHOD <(met)> ;
               => ;
               __InsMet(.F.,<(mess)>,{||<met>()})

#xcommand MESSAGE <(mess)> [,<messN>] <vir: VIRTUAL, IS NULL> ;
               => ;
               __insMet(.F.,<(mess)> ,{||svnil()}) ;
            [; __insMet(.F.,<(messN)>,{||svnil()})]


#xcommand MESSAGE <(mess)> [,<messN>] <def: IS DEFERRED> ;
               => ;
               __insMet(.F.,<(mess)> ,{||deferred()}) ;
            [; __insMet(.F.,<(messN)>,{||deferred()})]

#xcommand METHOD <met> <ctor: CONSTRUCTOR, CTOR> ;
               => ;
               __InsMet(.F.,"Init",{||<met>()})


/*
    CLASS METHOD ...            declare Class Method
    CLASS METHOD ... =          declare Class Method ...
    CLASS METHOD ... MESSAGE ..  .. with Message
*/

#xcommand _CMETHOD_ <(met)> [,<*messN*>] ;
               => ;
               __InsMet(.T.,<(met)>,{||<met>()}) [; _CMETHOD_ <messN>]

#xcommand CLASS METHOD <met> MESSAGE <(mess)> [,<*metN*>] ;
               => ;
               __InsMet(.T.,<(mess)>,{||<met>()}) [; CLASS METHOD <metN>]

#xcommand CLASS METHOD <met> <ctor: CONSTRUCTOR, CTOR> ;
               => ;
               __InsMet(.T.,"InitClass",{||<met>()})

#xcommand CLASS METHOD <(mess)> [,<messN>] <vir: VIRTUAL, IS NULL> ;
               => ;
               __insMet(.t.,<(mess)> ,{||svnil()}) ;
            [; __insMet(.t.,<(messN)>,{||svnil()})]

#xcommand CLASS METHOD <(mess)> [,<messN>] <def: IS DEFERRED> ;
               => ;
               __insMet(.T.,<(mess)> ,{||deferred()}) ;
            [; __insMet(.T.,<(messN)>,{||deferred()})]

